<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.3 of December 3, 2004 on March 14, 2006 at 6:29:34 pm</time-stamp>


<name-space>
<name>GiniTest</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>GiniTestCategory</category>
<attributes>
<package>GiniTest</package>
</attributes>
</name-space>


<class>
<name>GameTable</name>
<environment>CormasNS.Models.GiniTest</environment>
<super>CormasNS.Kernel.Group</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GiniTestCategory</category>
<attributes>
<package>GiniTest</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.GiniTest.GameTable</class-id> <category>control</category>

<body package="GiniTest" selector="step">step
	| players winner cashGambled |
	cashGambled := 10.
	players := self components select: [:p | p cash &gt;= cashGambled].
	players size &gt; 1 
		ifTrue: 
			[players do: [:p | p cash: p cash - cashGambled].
			winner := Cormas selectRandomlyFrom: players.
			winner cash: winner cash + (cashGambled * players size)]</body>
</methods>


<class>
<name>Person</name>
<environment>CormasNS.Models.GiniTest</environment>
<super>CormasNS.Kernel.Agent</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>cash </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GiniTestCategory</category>
<attributes>
<package>GiniTest</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.GiniTest.Person</class-id> <category>accessing</category>

<body package="GiniTest" selector="cash">cash
	"Getter accessor with default value = 100 "
	^cash ifNil:[cash := 100]</body>

<body package="GiniTest" selector="cash:">cash: anObject 
	cash := anObject</body>
</methods>


<class>
<name>GiniTest</name>
<environment>CormasNS.Models.GiniTest</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>thePersons theGameTables </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>GiniTestCategory</category>
<attributes>
<package>GiniTest</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.GiniTest.GiniTest class</class-id> <category>description</category>

<body package="GiniTest" selector="authors">authors
^ 'Nicolas'	</body>

<body package="GiniTest" selector="comments">comments
^ 'a model to test the Gini index method implemented as instance method of the CormasModel class.
To use the mehod add a probe to your model class sending ''self giniIndexOf: aCollec attribute: aSymbol''.
The Gini index is commonly used to measure income inequality in a society.
A value of 0 corresponds to perfect equality and 100 corresponds to perfect inequality (where one person has all the income, and everyone else has zero income).
See the comments of the method in the CormasModel class for more details'</body>

<body package="GiniTest" selector="creationDate">creationDate
^ '13 March 2006'	</body>

<body package="GiniTest" selector="emails">emails
^ 'becu@uni-hohenheim.de'	</body>

<body package="GiniTest" selector="lastUpdate">lastUpdate
^ 'March 14, 2006'	</body>

<body package="GiniTest" selector="version">version
^ 'GiniTest.st'	</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.GiniTest.GiniTest</class-id> <category>instance-creation</category>

<body package="GiniTest" selector="initAgents">initAgents
	super initAgents.
	self create: 10 groups: GameTable from: (self createN: 100 entity: Person)</body>
</methods>

<methods>
<class-id>CormasNS.Models.GiniTest.GiniTest</class-id> <category>init</category>

<body package="GiniTest" selector="init">init
	self initCells.
	self initAgents.
	HistogramsInterface newWith: self</body>
</methods>

<methods>
<class-id>CormasNS.Models.GiniTest.GiniTest</class-id> <category>control</category>

<body package="GiniTest" selector="step:">step: t 
	self stepEntities: self theGameTables</body>
</methods>

<methods>
<class-id>CormasNS.Models.GiniTest.GiniTest</class-id> <category>accessing</category>

<body package="GiniTest" selector="theGameTables">theGameTables
^theGameTables ifNil:[theGameTables := IndexedSet new]</body>

<body package="GiniTest" selector="theGameTables:">theGameTables: x
theGameTables := x</body>

<body package="GiniTest" selector="thePersons">thePersons
^thePersons ifNil:[thePersons := IndexedSet new]</body>

<body package="GiniTest" selector="thePersons:">thePersons: x
thePersons := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.GiniTest.GiniTest</class-id> <category>probes</category>

<body package="GiniTest" selector="averageCash">averageCash
	| tot |
	tot := 0.
	self thePersons do: [:p | tot := tot + p cash].
	^tot / self thePersons size</body>

<body package="GiniTest" selector="giniIndexOfCash">giniIndexOfCash
	^self giniIndexOf: self thePersons attribute: #cash</body>

<body package="GiniTest" selector="maxCash">maxCash
	^(SortedCollection withAll: self thePersons
		sortBlock: [:x :y | x cash &gt; y cash]) first cash</body>

<body package="GiniTest" selector="minCash">minCash
	^(SortedCollection withAll: self thePersons
		sortBlock: [:x :y | x cash &lt; y cash]) first cash</body>
</methods>

<methods>
<class-id>CormasNS.Models.GiniTest.GiniTest</class-id> <category>histograms</category>

<body package="GiniTest" selector="cashDistribution">cashDistribution
| individualData classes |
	individualData := OrderedCollection new.
	self thePersons do:[:i | individualData add: i cash].
	classes := #(0 25 50 75 100 200 400).
	^Array with: individualData with: classes</body>
</methods>



</st-source>
